// SendbkDlg.cpp : implementation file
//


//  Copyright Luis B. Almeida, 1996, 1998, 2002.
//  
//  This file is part of SendToBack.
//
//  SendToBack is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  SendToBack is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with SendToBack; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#include "stdafx.h"
#include "Sendbk.h"
#include "SendbkDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#define WM_MYTRAYCLICK WM_USER+1

typedef DWORD *dwordptr;

_declspec(dllimport) void Senddata(int, BOOL, BOOL, DWORD, BOOL, DWORD, BOOL, DWORD);

int command = 1;
DWORD hotKey1, hotKey2, hotKey3;
NOTIFYICONDATA icondata;

#define MY_HIDE (WPARAM) (6553600 + IDD_SENDBK_DIALOG)    // Command #100 * 65536 (high word) + IDD_SENDBK_DIALOG (low word)
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSendbkDlg dialog

CSendbkDlg::CSendbkDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSendbkDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSendbkDlg)
	m_icon = FALSE;
	m_mouseDisabled = FALSE;
	m_hotKey1Disabled = FALSE;
	m_hotKey2Disabled = FALSE;
	m_hotKey3Disabled = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSendbkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSendbkDlg)
	DDX_Control(pDX, IDC_HOTKEY3, m_hotKey3);
	DDX_Control(pDX, IDC_HOTKEY2, m_hotKey2);
	DDX_Check(pDX, IDC_CHECK2, m_icon);
	DDX_Check(pDX, IDC_CHECK1, m_mouseDisabled);
	DDX_Control(pDX, IDC_HOTKEY1, m_hotKey1);
	DDX_Check(pDX, IDC_CHECK3, m_hotKey1Disabled);
	DDX_Check(pDX, IDC_CHECK4, m_hotKey2Disabled);
	DDX_Check(pDX, IDC_CHECK5, m_hotKey3Disabled);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSendbkDlg, CDialog)
	//{{AFX_MSG_MAP(CSendbkDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OK, OnOk)
	ON_BN_CLICKED(IDC_RADIO2, OnMiddle)
	ON_MESSAGE(WM_MYTRAYCLICK, OnMyMessage)
	ON_BN_CLICKED(IDSAVE, OnSave)
	ON_BN_CLICKED(IDREMOVE, OnRemove)
	ON_BN_CLICKED(IDC_RADIO1, OnRight)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSendbkDlg message handlers

BOOL CSendbkDlg::OnInitDialog()
{

	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here


	PostMessage(WM_COMMAND, MY_HIDE, (LPARAM) 0);

	icondata.cbSize = sizeof(NOTIFYICONDATA);
	icondata.hWnd = m_hWnd;
	icondata.uID = 1;
	icondata.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	icondata.uCallbackMessage = WM_MYTRAYCLICK;
	icondata.hIcon = m_hIcon;
	lstrcpyn(icondata.szTip, "SendToBack", sizeof(icondata.szTip));

	command = GetPrivateProfileInt("SendToBack", "Command", 1, "Sendbk.ini");
	m_mouseDisabled = GetPrivateProfileInt("SendToBack", "MouseDisabled", 0, "Sendbk.ini") == 1;
	m_icon = GetPrivateProfileInt("SendToBack", "Icon", 1, "Sendbk.ini") == 1;
	m_hotKey1Disabled = GetPrivateProfileInt("SendToBack", "HotKey1Disabled", 1, "Sendbk.ini") == 1;
	m_hotKey2Disabled = GetPrivateProfileInt("SendToBack", "HotKey2Disabled", 1, "Sendbk.ini") == 1;
	m_hotKey3Disabled = GetPrivateProfileInt("SendToBack", "HotKey3Disabled", 1, "Sendbk.ini") == 1;
	hotKey1 = GetPrivateProfileInt("SendToBack", "HotKey1", 1602, "Sendbk.ini");
	m_hotKey1.SetHotKey(0xFF & (WORD) hotKey1,0xFF & (WORD) (hotKey1/256));
	hotKey2 = GetPrivateProfileInt("SendToBack", "HotKey2", 1606, "Sendbk.ini");
	m_hotKey2.SetHotKey(0xFF & (WORD) hotKey2,0xFF & (WORD) (hotKey2/256));
	hotKey3 = GetPrivateProfileInt("SendToBack", "HotKey3", 1620, "Sendbk.ini");
	m_hotKey3.SetHotKey(0xFF & (WORD) hotKey3,0xFF & (WORD) (hotKey3/256));

	UpdateData(FALSE);

	if (m_icon) Shell_NotifyIcon(NIM_ADD, &icondata);


	Senddata(command, m_mouseDisabled, m_hotKey1Disabled, hotKey1, m_hotKey2Disabled, hotKey2, m_hotKey3Disabled, hotKey3);

	switch(command)
	{
	case 1:
		CheckRadioButton(IDC_RADIO1, IDC_RADIO1, IDC_RADIO1);
		break;
	case 2:
		CheckRadioButton(IDC_RADIO2, IDC_RADIO2, IDC_RADIO2);
		break;
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSendbkDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSendbkDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSendbkDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSendbkDlg::OnOk() 
{
	// TODO: Add your control notification handler code here


	UpdateData(TRUE);

	
	if (m_icon)
		Shell_NotifyIcon(NIM_ADD, &icondata);
	else
		Shell_NotifyIcon(NIM_DELETE, &icondata);

	hotKey1 = m_hotKey1.GetHotKey();
	hotKey2 = m_hotKey2.GetHotKey();
	hotKey3 = m_hotKey3.GetHotKey();

	if ((hotKey1==hotKey2 && hotKey1!=0) || (hotKey2==hotKey3 && hotKey2!=0) || (hotKey3==hotKey1 && hotKey3!=0))
		Beep(0,0);
	else
	{
		Senddata(command, m_mouseDisabled, m_hotKey1Disabled, hotKey1, m_hotKey2Disabled, hotKey2, m_hotKey3Disabled, hotKey3);

		ShowWindow(SW_HIDE);
	}

}

BEGIN_EVENTSINK_MAP(CSendbkDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CSendbkDlg)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()


void CSendbkDlg::OnRight() 
{
	// TODO: Add your control notification handler code here
	command = 1;
}

void CSendbkDlg::OnMiddle() 
{
	// TODO: Add your control notification handler code here
	command = 2;
}

BOOL CSendbkDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	if (wParam == MY_HIDE) ShowWindow(SW_HIDE);

	return CDialog::OnCommand(wParam, lParam);
}

LRESULT CSendbkDlg::OnMyMessage(WPARAM wParam, LPARAM lParam)
{
	UINT uID; 
    UINT uMouseMsg; 
 
    uID = (UINT) wParam; 
    uMouseMsg = (UINT) lParam; 
 
    if (uMouseMsg == WM_LBUTTONDOWN && uID == 1)
	{
		ShowWindow(SW_HIDE);
		ShowWindow(SW_SHOWNORMAL);
	}
	return 0;
}


void CSendbkDlg::OnSave() 
{
	// TODO: Add your control notification handler code here
	char buffer[20];
	
	if ((hotKey1==hotKey2 && hotKey1!=0) || (hotKey2==hotKey3 && hotKey2!=0) || (hotKey3==hotKey1 && hotKey3!=0))
		Beep(0,0);
	else
		UpdateData(TRUE);

	if (m_icon)
		Shell_NotifyIcon(NIM_ADD, &icondata);
	else
		Shell_NotifyIcon(NIM_DELETE, &icondata);


		WritePrivateProfileString("SendToBack", "Command", _itoa(command, buffer, 10), "Sendbk.ini");
		WritePrivateProfileString("SendToBack", "MouseDisabled", _itoa((int) m_mouseDisabled, buffer, 10), "Sendbk.ini");
		WritePrivateProfileString("SendToBack", "Icon", _itoa((int) m_icon, buffer, 10), "Sendbk.ini");
		WritePrivateProfileString("SendToBack", "HotKey1Disabled", _itoa((int) m_hotKey1Disabled, buffer, 10), "Sendbk.ini");
		hotKey1 = m_hotKey1.GetHotKey();
		WritePrivateProfileString("SendToBack", "HotKey1", _itoa((int) hotKey1, buffer, 10), "Sendbk.ini");
		WritePrivateProfileString("SendToBack", "HotKey2Disabled", _itoa((int) m_hotKey2Disabled, buffer, 10), "Sendbk.ini");
		hotKey2 = m_hotKey2.GetHotKey();
		WritePrivateProfileString("SendToBack", "HotKey2", _itoa((int) hotKey2, buffer, 10), "Sendbk.ini");
		WritePrivateProfileString("SendToBack", "HotKey3Disabled", _itoa((int) m_hotKey3Disabled, buffer, 10), "Sendbk.ini");
		hotKey3 = m_hotKey3.GetHotKey();
		WritePrivateProfileString("SendToBack", "HotKey3", _itoa((int) hotKey3, buffer, 10), "Sendbk.ini");

		Senddata(command, m_mouseDisabled, m_hotKey1Disabled, hotKey1, m_hotKey2Disabled, hotKey2, m_hotKey3Disabled, hotKey3);

}

void CSendbkDlg::OnCancel() 
{
	// We come here if the close button (on the top-right corner of the dialog) has been pressed

	// Perform the same actions as if the OK button had been pressed
	
	CSendbkDlg::OnOk();
}

void CSendbkDlg::OnRemove() 
{
	// If there is an icon in the tray, delete it. Then, terminate.

	if (m_icon) Shell_NotifyIcon(NIM_DELETE, &icondata);

	
	CDialog::OnCancel();
}


