// SendbkDlg.h : header file
//


//  Copyright Luis B. Almeida, 1996, 1998, 2002.
//  
//  This file is part of SendToBack.
//
//  SendToBack is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  SendToBack is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with SendToBack; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


/////////////////////////////////////////////////////////////////////////////
// CSendbkDlg dialog
//{{AFX_INCLUDES()
//}}AFX_INCLUDES

class CSendbkDlg : public CDialog
{
// Construction
public:
	CSendbkDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CSendbkDlg)
	enum { IDD = IDD_SENDBK_DIALOG };
	CHotKeyCtrl	m_hotKey3;
	CHotKeyCtrl	m_hotKey2;
	CHotKeyCtrl	m_hotKey1;
	BOOL	m_icon;
	BOOL	m_mouseDisabled;
	BOOL	m_hotKey1Disabled;
	BOOL	m_hotKey2Disabled;
	BOOL	m_hotKey3Disabled;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSendbkDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CSendbkDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnOk();
	afx_msg void OnMiddle();
	afx_msg LRESULT OnMyMessage(WPARAM wParam, LPARAM lParam);
	afx_msg void OnSave();
	virtual void OnCancel();
	afx_msg void OnRemove();
	afx_msg void OnRight();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
